// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

// Begin prologue.
//
#include <bpkg/types-parsers>
//
// End prologue.

#include <bpkg/bpkg-options>

#include <map>
#include <set>
#include <string>
#include <vector>
#include <ostream>
#include <sstream>

namespace bpkg
{
  namespace cli
  {
    template <typename X>
    struct parser
    {
      static void
      parse (X& x, bool& xs, scanner& s)
      {
        using namespace std;

        string o (s.next ());

        if (s.more ())
        {
          string v (s.next ());
          istringstream is (v);
          if (!(is >> x && is.peek () == istringstream::traits_type::eof ()))
            throw invalid_value (o, v);
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <>
    struct parser<bool>
    {
      static void
      parse (bool& x, scanner& s)
      {
        s.next ();
        x = true;
      }
    };

    template <>
    struct parser<std::string>
    {
      static void
      parse (std::string& x, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
          x = s.next ();
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X>
    struct parser<std::vector<X> >
    {
      static void
      parse (std::vector<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.push_back (x);
        xs = true;
      }
    };

    template <typename X>
    struct parser<std::set<X> >
    {
      static void
      parse (std::set<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.insert (x);
        xs = true;
      }
    };

    template <typename K, typename V>
    struct parser<std::map<K, V> >
    {
      static void
      parse (std::map<K, V>& m, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
        {
          std::string ov (s.next ());
          std::string::size_type p = ov.find ('=');

          K k = K ();
          V v = V ();
          std::string kstr (ov, 0, p);
          std::string vstr (ov, (p != std::string::npos ? p + 1 : ov.size ()));

          int ac (2);
          char* av[] = 
          {
            const_cast<char*> (o), 0
          };

          bool dummy;
          if (!kstr.empty ())
          {
            av[1] = const_cast<char*> (kstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<K>::parse (k, dummy, s);
          }

          if (!vstr.empty ())
          {
            av[1] = const_cast<char*> (vstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<V>::parse (v, dummy, s);
          }

          m[k] = v;
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X, typename T, T X::*M>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, s);
    }

    template <typename X, typename T, T X::*M, bool X::*S>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, x.*S, s);
    }
  }
}

#include <map>
#include <cstring>

namespace bpkg
{
  // commands
  //

  commands::
  commands ()
  : help_ (),
    cfg_create_ (),
    rep_info_ (),
    rep_add_ (),
    rep_fetch_ (),
    rep_create_ (),
    pkg_status_ (),
    pkg_build_ (),
    pkg_drop_ (),
    pkg_install_ (),
    pkg_uninstall_ (),
    pkg_update_ (),
    pkg_test_ (),
    pkg_clean_ (),
    pkg_verify_ (),
    pkg_fetch_ (),
    pkg_unpack_ (),
    pkg_configure_ (),
    pkg_disfigure_ (),
    pkg_purge_ ()
  {
  }

  void commands::
  parse (int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
  }

  void commands::
  parse (int start,
         int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
  }

  void commands::
  parse (int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void commands::
  parse (int start,
         int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void commands::
  parse (::bpkg::cli::scanner& s,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    _parse (s, opt, arg);
  }

  ::bpkg::cli::usage_para commands::
  print_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mCOMMANDS\033[0m" << ::std::endl;

    os << std::endl
       << "\033[1mhelp\033[0m [\033[4mtopic\033[0m]            \033[1mbpkg-help(1)\033[0m -- show help for a command or help topic" << ::std::endl;

    os << "\033[1mcfg-create\033[0m|\033[1mcreate\033[0m       \033[1mbpkg-cfg-create(1)\033[0m -- create configuration" << ::std::endl;

    os << "\033[1mrep-info\033[0m                \033[1mbpkg-rep-info(1)\033[0m -- print repository information" << ::std::endl;

    os << "\033[1mrep-add\033[0m|\033[1madd\033[0m             \033[1mbpkg-rep-add(1)\033[0m -- add repository to configuration" << ::std::endl;

    os << "\033[1mrep-fetch\033[0m|\033[1mfetch\033[0m         \033[1mbpkg-rep-fetch(1)\033[0m -- fetch list of available packages" << ::std::endl;

    os << "\033[1mrep-create\033[0m [\033[4mdir\033[0m]        \033[1mbpkg-rep-create(1)\033[0m -- create repository" << ::std::endl;

    os << "\033[1mpkg-status\033[0m|\033[1mstatus\033[0m       \033[1mbpkg-pkg-status(1)\033[0m -- print package status" << ::std::endl;

    os << "\033[1mpkg-build\033[0m|\033[1mbuild\033[0m         \033[1mbpkg-pkg-build(1)\033[0m -- build package" << ::std::endl;

    os << "\033[1mpkg-drop\033[0m|\033[1mdrop\033[0m           \033[1mbpkg-pkg-drop(1)\033[0m -- drop package" << ::std::endl;

    os << "\033[1mpkg-install\033[0m|\033[1minstall\033[0m     \033[1mbpkg-pkg-install(1)\033[0m -- install package" << ::std::endl;

    os << "\033[1mpkg-uninstall\033[0m|\033[1muninstall\033[0m \033[1mbpkg-pkg-uninstall(1)\033[0m -- uninstall package" << ::std::endl;

    os << "\033[1mpkg-update\033[0m|\033[1mupdate\033[0m       \033[1mbpkg-pkg-update(1)\033[0m -- update package" << ::std::endl;

    os << "\033[1mpkg-test\033[0m|\033[1mtest\033[0m           \033[1mbpkg-pkg-test(1)\033[0m -- test package" << ::std::endl;

    os << "\033[1mpkg-clean\033[0m|\033[1mclean\033[0m         \033[1mbpkg-pkg-clean(1)\033[0m -- clean package" << ::std::endl;

    os << "\033[1mpkg-verify\033[0m \033[4marchive\033[0m      \033[1mbpkg-pkg-verify(1)\033[0m -- verify package archive" << ::std::endl;

    os << "\033[1mpkg-fetch\033[0m               \033[1mbpkg-pkg-fetch(1)\033[0m -- fetch package archive" << ::std::endl;

    os << "\033[1mpkg-unpack\033[0m              \033[1mbpkg-pkg-unpack(1)\033[0m -- unpack package archive" << ::std::endl;

    os << "\033[1mpkg-configure\033[0m           \033[1mbpkg-pkg-configure(1)\033[0m -- configure package" << ::std::endl;

    os << "\033[1mpkg-disfigure\033[0m           \033[1mbpkg-pkg-disfigure(1)\033[0m -- disfigure package" << ::std::endl;

    os << "\033[1mpkg-purge\033[0m               \033[1mbpkg-pkg-purge(1)\033[0m -- purge package" << ::std::endl;

    p = ::bpkg::cli::usage_para::option;

    return p;
  }

  typedef
  std::map<std::string, void (*) (commands&, ::bpkg::cli::scanner&)>
  _cli_commands_map;

  static _cli_commands_map _cli_commands_map_;

  struct _cli_commands_map_init
  {
    _cli_commands_map_init ()
    {
      _cli_commands_map_["help"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::help_ >;
      _cli_commands_map_["cfg-create"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::cfg_create_ >;
      _cli_commands_map_["create"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::cfg_create_ >;
      _cli_commands_map_["rep-info"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::rep_info_ >;
      _cli_commands_map_["rep-add"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::rep_add_ >;
      _cli_commands_map_["add"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::rep_add_ >;
      _cli_commands_map_["rep-fetch"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::rep_fetch_ >;
      _cli_commands_map_["fetch"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::rep_fetch_ >;
      _cli_commands_map_["rep-create"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::rep_create_ >;
      _cli_commands_map_["pkg-status"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_status_ >;
      _cli_commands_map_["status"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_status_ >;
      _cli_commands_map_["pkg-build"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_build_ >;
      _cli_commands_map_["build"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_build_ >;
      _cli_commands_map_["pkg-drop"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_drop_ >;
      _cli_commands_map_["drop"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_drop_ >;
      _cli_commands_map_["pkg-install"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_install_ >;
      _cli_commands_map_["install"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_install_ >;
      _cli_commands_map_["pkg-uninstall"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_uninstall_ >;
      _cli_commands_map_["uninstall"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_uninstall_ >;
      _cli_commands_map_["pkg-update"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_update_ >;
      _cli_commands_map_["update"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_update_ >;
      _cli_commands_map_["pkg-test"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_test_ >;
      _cli_commands_map_["test"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_test_ >;
      _cli_commands_map_["pkg-clean"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_clean_ >;
      _cli_commands_map_["clean"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_clean_ >;
      _cli_commands_map_["pkg-verify"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_verify_ >;
      _cli_commands_map_["pkg-fetch"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_fetch_ >;
      _cli_commands_map_["pkg-unpack"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_unpack_ >;
      _cli_commands_map_["pkg-configure"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_configure_ >;
      _cli_commands_map_["pkg-disfigure"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_disfigure_ >;
      _cli_commands_map_["pkg-purge"] = 
      &::bpkg::cli::thunk< commands, bool, &commands::pkg_purge_ >;
    }
  };

  static _cli_commands_map_init _cli_commands_map_init_;

  bool commands::
  _parse (const char* o, ::bpkg::cli::scanner& s)
  {
    _cli_commands_map::const_iterator i (_cli_commands_map_.find (o));

    if (i != _cli_commands_map_.end ())
    {
      (*(i->second)) (*this, s);
      return true;
    }

    return false;
  }

  void commands::
  _parse (::bpkg::cli::scanner& s,
          ::bpkg::cli::unknown_mode opt_mode,
          ::bpkg::cli::unknown_mode arg_mode)
  {
    bool opt = true;

    while (s.more ())
    {
      const char* o = s.peek ();

      if (std::strcmp (o, "--") == 0)
      {
        s.skip ();
        opt = false;
        continue;
      }

      if (opt && _parse (o, s));
      else if (opt && std::strncmp (o, "-", 1) == 0 && o[1] != '\0')
      {
        switch (opt_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_option (o);
          }
        }

        break;
      }
      else
      {
        switch (arg_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_argument (o);
          }
        }

        break;
      }
    }
  }

  // topics
  //

  topics::
  topics ()
  : common_options_ (),
    repository_signing_ ()
  {
  }

  void topics::
  parse (int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
  }

  void topics::
  parse (int start,
         int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
  }

  void topics::
  parse (int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void topics::
  parse (int start,
         int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void topics::
  parse (::bpkg::cli::scanner& s,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    _parse (s, opt, arg);
  }

  ::bpkg::cli::usage_para topics::
  print_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mHELP TOPICS\033[0m" << ::std::endl;

    os << std::endl
       << "\033[1mcommon-options\033[0m          \033[1mbpkg-common-options(1)\033[0m -- details on common options" << ::std::endl;

    os << "\033[1mrepository-signing\033[0m      \033[1mbpkg-repository-signing(1)\033[0m -- how to sign repository" << ::std::endl;

    p = ::bpkg::cli::usage_para::option;

    return p;
  }

  typedef
  std::map<std::string, void (*) (topics&, ::bpkg::cli::scanner&)>
  _cli_topics_map;

  static _cli_topics_map _cli_topics_map_;

  struct _cli_topics_map_init
  {
    _cli_topics_map_init ()
    {
      _cli_topics_map_["common-options"] = 
      &::bpkg::cli::thunk< topics, bool, &topics::common_options_ >;
      _cli_topics_map_["repository-signing"] = 
      &::bpkg::cli::thunk< topics, bool, &topics::repository_signing_ >;
    }
  };

  static _cli_topics_map_init _cli_topics_map_init_;

  bool topics::
  _parse (const char* o, ::bpkg::cli::scanner& s)
  {
    _cli_topics_map::const_iterator i (_cli_topics_map_.find (o));

    if (i != _cli_topics_map_.end ())
    {
      (*(i->second)) (*this, s);
      return true;
    }

    return false;
  }

  void topics::
  _parse (::bpkg::cli::scanner& s,
          ::bpkg::cli::unknown_mode opt_mode,
          ::bpkg::cli::unknown_mode arg_mode)
  {
    bool opt = true;

    while (s.more ())
    {
      const char* o = s.peek ();

      if (std::strcmp (o, "--") == 0)
      {
        s.skip ();
        opt = false;
        continue;
      }

      if (opt && _parse (o, s));
      else if (opt && std::strncmp (o, "-", 1) == 0 && o[1] != '\0')
      {
        switch (opt_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_option (o);
          }
        }

        break;
      }
      else
      {
        switch (arg_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_argument (o);
          }
        }

        break;
      }
    }
  }

  // options
  //

  options::
  options ()
  : help_ (),
    version_ ()
  {
  }

  void options::
  parse (int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
  }

  void options::
  parse (int start,
         int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
  }

  void options::
  parse (int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void options::
  parse (int start,
         int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void options::
  parse (::bpkg::cli::scanner& s,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    _parse (s, opt, arg);
  }

  ::bpkg::cli::usage_para options::
  print_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    // common_options base
    //
    p = ::bpkg::common_options::print_usage (os, p);

    return p;
  }

  typedef
  std::map<std::string, void (*) (options&, ::bpkg::cli::scanner&)>
  _cli_options_map;

  static _cli_options_map _cli_options_map_;

  struct _cli_options_map_init
  {
    _cli_options_map_init ()
    {
      _cli_options_map_["--help"] = 
      &::bpkg::cli::thunk< options, bool, &options::help_ >;
      _cli_options_map_["--version"] = 
      &::bpkg::cli::thunk< options, bool, &options::version_ >;
    }
  };

  static _cli_options_map_init _cli_options_map_init_;

  bool options::
  _parse (const char* o, ::bpkg::cli::scanner& s)
  {
    _cli_options_map::const_iterator i (_cli_options_map_.find (o));

    if (i != _cli_options_map_.end ())
    {
      (*(i->second)) (*this, s);
      return true;
    }

    // common_options base
    //
    if (::bpkg::common_options::_parse (o, s))
      return true;

    return false;
  }

  void options::
  _parse (::bpkg::cli::scanner& s,
          ::bpkg::cli::unknown_mode opt_mode,
          ::bpkg::cli::unknown_mode arg_mode)
  {
    bool opt = true;

    while (s.more ())
    {
      const char* o = s.peek ();

      if (std::strcmp (o, "--") == 0)
      {
        s.skip ();
        opt = false;
        continue;
      }

      if (opt && _parse (o, s));
      else if (opt && std::strncmp (o, "-", 1) == 0 && o[1] != '\0')
      {
        switch (opt_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_option (o);
          }
        }

        break;
      }
      else
      {
        switch (arg_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_argument (o);
          }
        }

        break;
      }
    }
  }
}

namespace bpkg
{
  ::bpkg::cli::usage_para
  print_bpkg_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mSYNOPSIS\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mbpkg --help\033[0m" << ::std::endl
       << "\033[1mbpkg --version\033[0m" << ::std::endl
       << "\033[1mbpkg help\033[0m [\033[4mcommand\033[0m | \033[4mtopic\033[0m]\033[0m" << ::std::endl
       << "\033[1mbpkg\033[0m [\033[4mcommon-options\033[0m] \033[4mcommand\033[0m [\033[4mcommand-options\033[0m] \033[4mcommand-args\033[0m\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mDESCRIPTION\033[0m" << ::std::endl
       << ::std::endl
       << "The \033[1mbuild2\033[0m package manager is used to manipulate configurations, packages, and" << ::std::endl
       << "repositories using a set of commands that are summarized below." << ::std::endl
       << ::std::endl
       << "For a detailed description of any command or help topic, use the \033[1mhelp\033[0m command" << ::std::endl
       << "or see the corresponding man page (the man pages have the \033[1mbpkg-\033[0m prefix, for" << ::std::endl
       << "example \033[1mbpkg-help(1)\033[0m). Note also that \033[4mcommand-options\033[0m and \033[4mcommand-args\033[0m can be" << ::std::endl
       << "specified in any order and \033[4mcommon-options\033[0m can be specified as part of" << ::std::endl
       << "\033[4mcommand-options\033[0m." << ::std::endl;

    p = ::bpkg::commands::print_usage (os, ::bpkg::cli::usage_para::text);

    p = ::bpkg::topics::print_usage (os, p);

    p = ::bpkg::options::print_usage (os, p);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mEXIT STATUS\033[0m" << ::std::endl
       << ::std::endl
       << "Non-zero exit status is returned in case of an error." << ::std::endl;

    p = ::bpkg::cli::usage_para::text;

    return p;
  }
}

// Begin epilogue.
//
//
// End epilogue.

