// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

// Begin prologue.
//
#include <bpkg/types-parsers>
//
// End prologue.

#include <bpkg/cfg-create-options>

#include <map>
#include <set>
#include <string>
#include <vector>
#include <ostream>
#include <sstream>

namespace bpkg
{
  namespace cli
  {
    template <typename X>
    struct parser
    {
      static void
      parse (X& x, bool& xs, scanner& s)
      {
        using namespace std;

        string o (s.next ());

        if (s.more ())
        {
          string v (s.next ());
          istringstream is (v);
          if (!(is >> x && is.peek () == istringstream::traits_type::eof ()))
            throw invalid_value (o, v);
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <>
    struct parser<bool>
    {
      static void
      parse (bool& x, scanner& s)
      {
        s.next ();
        x = true;
      }
    };

    template <>
    struct parser<std::string>
    {
      static void
      parse (std::string& x, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
          x = s.next ();
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X>
    struct parser<std::vector<X> >
    {
      static void
      parse (std::vector<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.push_back (x);
        xs = true;
      }
    };

    template <typename X>
    struct parser<std::set<X> >
    {
      static void
      parse (std::set<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.insert (x);
        xs = true;
      }
    };

    template <typename K, typename V>
    struct parser<std::map<K, V> >
    {
      static void
      parse (std::map<K, V>& m, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
        {
          std::string ov (s.next ());
          std::string::size_type p = ov.find ('=');

          K k = K ();
          V v = V ();
          std::string kstr (ov, 0, p);
          std::string vstr (ov, (p != std::string::npos ? p + 1 : ov.size ()));

          int ac (2);
          char* av[] = 
          {
            const_cast<char*> (o), 0
          };

          bool dummy;
          if (!kstr.empty ())
          {
            av[1] = const_cast<char*> (kstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<K>::parse (k, dummy, s);
          }

          if (!vstr.empty ())
          {
            av[1] = const_cast<char*> (vstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<V>::parse (v, dummy, s);
          }

          m[k] = v;
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X, typename T, T X::*M>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, s);
    }

    template <typename X, typename T, T X::*M, bool X::*S>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, x.*S, s);
    }
  }
}

#include <map>
#include <cstring>

namespace bpkg
{
  // cfg_create_options
  //

  cfg_create_options::
  cfg_create_options ()
  : directory_ ("."),
    directory_specified_ (false),
    wipe_ ()
  {
  }

  void cfg_create_options::
  parse (int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
  }

  void cfg_create_options::
  parse (int start,
         int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
  }

  void cfg_create_options::
  parse (int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void cfg_create_options::
  parse (int start,
         int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void cfg_create_options::
  parse (::bpkg::cli::scanner& s,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    _parse (s, opt, arg);
  }

  ::bpkg::cli::usage_para cfg_create_options::
  print_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mCFG-CREATE OPTIONS\033[0m" << ::std::endl;

    os << std::endl
       << "\033[1m--directory\033[0m|\033[1m-d\033[0m \033[4mdir\033[0m      Create the configuration in \033[4mdir\033[0m rather than in the" << ::std::endl
       << "                        current working directory." << ::std::endl;

    os << std::endl
       << "\033[1m--wipe\033[0m                  Wipe the configuration directory clean before creating" << ::std::endl
       << "                        the new configuration. For safety, this option requires" << ::std::endl
       << "                        that you specify the configuration directory explicitly" << ::std::endl
       << "                        with \033[1m--directory|-d\033[0m." << ::std::endl;

    p = ::bpkg::cli::usage_para::option;

    // common_options base
    //
    p = ::bpkg::common_options::print_usage (os, p);

    return p;
  }

  typedef
  std::map<std::string, void (*) (cfg_create_options&, ::bpkg::cli::scanner&)>
  _cli_cfg_create_options_map;

  static _cli_cfg_create_options_map _cli_cfg_create_options_map_;

  struct _cli_cfg_create_options_map_init
  {
    _cli_cfg_create_options_map_init ()
    {
      _cli_cfg_create_options_map_["--directory"] = 
      &::bpkg::cli::thunk< cfg_create_options, dir_path, &cfg_create_options::directory_,
        &cfg_create_options::directory_specified_ >;
      _cli_cfg_create_options_map_["-d"] = 
      &::bpkg::cli::thunk< cfg_create_options, dir_path, &cfg_create_options::directory_,
        &cfg_create_options::directory_specified_ >;
      _cli_cfg_create_options_map_["--wipe"] = 
      &::bpkg::cli::thunk< cfg_create_options, bool, &cfg_create_options::wipe_ >;
    }
  };

  static _cli_cfg_create_options_map_init _cli_cfg_create_options_map_init_;

  bool cfg_create_options::
  _parse (const char* o, ::bpkg::cli::scanner& s)
  {
    _cli_cfg_create_options_map::const_iterator i (_cli_cfg_create_options_map_.find (o));

    if (i != _cli_cfg_create_options_map_.end ())
    {
      (*(i->second)) (*this, s);
      return true;
    }

    // common_options base
    //
    if (::bpkg::common_options::_parse (o, s))
      return true;

    return false;
  }

  void cfg_create_options::
  _parse (::bpkg::cli::scanner& s,
          ::bpkg::cli::unknown_mode opt_mode,
          ::bpkg::cli::unknown_mode arg_mode)
  {
    bool opt = true;

    while (s.more ())
    {
      const char* o = s.peek ();

      if (std::strcmp (o, "--") == 0)
      {
        s.skip ();
        opt = false;
        continue;
      }

      if (opt && _parse (o, s));
      else if (opt && std::strncmp (o, "-", 1) == 0 && o[1] != '\0')
      {
        switch (opt_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_option (o);
          }
        }

        break;
      }
      else
      {
        switch (arg_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_argument (o);
          }
        }

        break;
      }
    }
  }
}

namespace bpkg
{
  ::bpkg::cli::usage_para
  print_bpkg_cfg_create_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mSYNOPSIS\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mbpkg cfg-create\033[0m|\033[1mcreate\033[0m [\033[4moptions\033[0m] [(\033[4mmodule\033[0m | \033[4mconf-var\033[0m)...]\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mDESCRIPTION\033[0m" << ::std::endl
       << ::std::endl
       << "The \033[1mcfg-create\033[0m command creates a new \033[1mbpkg\033[0m configuration with the specified" << ::std::endl
       << "\033[1mbuild2\033[0m modules and configuration variables. Unless the \033[1m--wipe\033[0m option is" << ::std::endl
       << "specified, \033[1mcfg-create\033[0m expects the configuration directory to be empty or to not" << ::std::endl
       << "exist (in which case it will be created)." << ::std::endl
       << ::std::endl
       << "By default, the resulting configuration loads the \033[1mconfig\033[0m, \033[1mtest\033[0m, and \033[1minstall\033[0m" << ::std::endl
       << "modules. However, additional modules and, if required, their configuration" << ::std::endl
       << "variables can be specified as the \033[1mcfg-create\033[0m arguments. For example:" << ::std::endl
       << ::std::endl
       << "bpkg create cxx config.cxx=clang++ config.install.root=/usr/local" << ::std::endl
       << ::std::endl
       << "By default, \033[1mbpkg\033[0m appends \033[1m.config\033[0m to the names of the modules that you specify" << ::std::endl
       << "so that only their configurations are loaded. You can override this behavior by" << ::std::endl
       << "appending the period (\033[1m.\033[0m)  after the module name. You can also instruct \033[1mbpkg\033[0m to" << ::std::endl
       << "use the optional module load by prefixing the module name with the question" << ::std::endl
       << "mark (\033[1m?\033[0m). For example:" << ::std::endl
       << ::std::endl
       << "bpkg create cxx. \"?cli\"" << ::std::endl;

    p = ::bpkg::cfg_create_options::print_usage (os, ::bpkg::cli::usage_para::text);

    return p;
  }
}

// Begin epilogue.
//
//
// End epilogue.

