// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

// Begin prologue.
//
#include <bpkg/types-parsers>
//
// End prologue.

#include <bpkg/pkg-build-options>

#include <map>
#include <set>
#include <string>
#include <vector>
#include <ostream>
#include <sstream>

namespace bpkg
{
  namespace cli
  {
    template <typename X>
    struct parser
    {
      static void
      parse (X& x, bool& xs, scanner& s)
      {
        using namespace std;

        string o (s.next ());

        if (s.more ())
        {
          string v (s.next ());
          istringstream is (v);
          if (!(is >> x && is.peek () == istringstream::traits_type::eof ()))
            throw invalid_value (o, v);
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <>
    struct parser<bool>
    {
      static void
      parse (bool& x, scanner& s)
      {
        s.next ();
        x = true;
      }
    };

    template <>
    struct parser<std::string>
    {
      static void
      parse (std::string& x, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
          x = s.next ();
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X>
    struct parser<std::vector<X> >
    {
      static void
      parse (std::vector<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.push_back (x);
        xs = true;
      }
    };

    template <typename X>
    struct parser<std::set<X> >
    {
      static void
      parse (std::set<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.insert (x);
        xs = true;
      }
    };

    template <typename K, typename V>
    struct parser<std::map<K, V> >
    {
      static void
      parse (std::map<K, V>& m, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
        {
          std::string ov (s.next ());
          std::string::size_type p = ov.find ('=');

          K k = K ();
          V v = V ();
          std::string kstr (ov, 0, p);
          std::string vstr (ov, (p != std::string::npos ? p + 1 : ov.size ()));

          int ac (2);
          char* av[] = 
          {
            const_cast<char*> (o), 0
          };

          bool dummy;
          if (!kstr.empty ())
          {
            av[1] = const_cast<char*> (kstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<K>::parse (k, dummy, s);
          }

          if (!vstr.empty ())
          {
            av[1] = const_cast<char*> (vstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<V>::parse (v, dummy, s);
          }

          m[k] = v;
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X, typename T, T X::*M>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, s);
    }

    template <typename X, typename T, T X::*M, bool X::*S>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, x.*S, s);
    }
  }
}

#include <map>
#include <cstring>

namespace bpkg
{
  // pkg_build_options
  //

  pkg_build_options::
  pkg_build_options ()
  : yes_ (),
    drop_prerequisite_ (),
    keep_prerequisite_ (),
    update_dependent_ (),
    leave_dependent_ (),
    print_only_ (),
    configure_only_ ()
  {
  }

  void pkg_build_options::
  parse (int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
  }

  void pkg_build_options::
  parse (int start,
         int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
  }

  void pkg_build_options::
  parse (int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void pkg_build_options::
  parse (int start,
         int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void pkg_build_options::
  parse (::bpkg::cli::scanner& s,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    _parse (s, opt, arg);
  }

  ::bpkg::cli::usage_para pkg_build_options::
  print_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mPKG-BUILD OPTIONS\033[0m" << ::std::endl;

    os << std::endl
       << "\033[1m--yes\033[0m|\033[1m-y\033[0m                Assume the answer to all prompts is \033[1myes\033[0m." << ::std::endl;

    os << std::endl
       << "\033[1m--drop-prerequisite\033[0m|\033[1m-D\033[0m  Drop without confirmation prerequsite packages that" << ::std::endl
       << "                        were automatically built and will no longer be" << ::std::endl
       << "                        necessary." << ::std::endl;

    os << std::endl
       << "\033[1m--keep-prerequisite\033[0m|\033[1m-K\033[0m  Don't offer to drop prerequsite packages that were" << ::std::endl
       << "                        automatically built and will no longer be necessary." << ::std::endl;

    os << std::endl
       << "\033[1m--update-dependent\033[0m|\033[1m-U\033[0m   Update without confirmation dependent packages that are" << ::std::endl
       << "                        reconfigured due to their prerequisites being upgraded" << ::std::endl
       << "                        or downgraded." << ::std::endl;

    os << std::endl
       << "\033[1m--leave-dependent\033[0m|\033[1m-L\033[0m    Don't offer to update dependent packages that are" << ::std::endl
       << "                        reconfigured due to their prerequisites being upgraded" << ::std::endl
       << "                        or downgraded." << ::std::endl;

    os << std::endl
       << "\033[1m--print-only\033[0m|\033[1m-p\033[0m         Print to \033[1mSTDOUT\033[0m what would be done without actually" << ::std::endl
       << "                        doing anything." << ::std::endl;

    os << std::endl
       << "\033[1m--configure-only\033[0m|\033[1m-c\033[0m     Configure all the packages but don't update." << ::std::endl;

    p = ::bpkg::cli::usage_para::option;

    // configuration_options base
    //
    p = ::bpkg::configuration_options::print_usage (os, p);

    return p;
  }

  typedef
  std::map<std::string, void (*) (pkg_build_options&, ::bpkg::cli::scanner&)>
  _cli_pkg_build_options_map;

  static _cli_pkg_build_options_map _cli_pkg_build_options_map_;

  struct _cli_pkg_build_options_map_init
  {
    _cli_pkg_build_options_map_init ()
    {
      _cli_pkg_build_options_map_["--yes"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::yes_ >;
      _cli_pkg_build_options_map_["-y"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::yes_ >;
      _cli_pkg_build_options_map_["--drop-prerequisite"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::drop_prerequisite_ >;
      _cli_pkg_build_options_map_["-D"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::drop_prerequisite_ >;
      _cli_pkg_build_options_map_["--keep-prerequisite"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::keep_prerequisite_ >;
      _cli_pkg_build_options_map_["-K"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::keep_prerequisite_ >;
      _cli_pkg_build_options_map_["--update-dependent"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::update_dependent_ >;
      _cli_pkg_build_options_map_["-U"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::update_dependent_ >;
      _cli_pkg_build_options_map_["--leave-dependent"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::leave_dependent_ >;
      _cli_pkg_build_options_map_["-L"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::leave_dependent_ >;
      _cli_pkg_build_options_map_["--print-only"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::print_only_ >;
      _cli_pkg_build_options_map_["-p"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::print_only_ >;
      _cli_pkg_build_options_map_["--configure-only"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::configure_only_ >;
      _cli_pkg_build_options_map_["-c"] = 
      &::bpkg::cli::thunk< pkg_build_options, bool, &pkg_build_options::configure_only_ >;
    }
  };

  static _cli_pkg_build_options_map_init _cli_pkg_build_options_map_init_;

  bool pkg_build_options::
  _parse (const char* o, ::bpkg::cli::scanner& s)
  {
    _cli_pkg_build_options_map::const_iterator i (_cli_pkg_build_options_map_.find (o));

    if (i != _cli_pkg_build_options_map_.end ())
    {
      (*(i->second)) (*this, s);
      return true;
    }

    // configuration_options base
    //
    if (::bpkg::configuration_options::_parse (o, s))
      return true;

    return false;
  }

  void pkg_build_options::
  _parse (::bpkg::cli::scanner& s,
          ::bpkg::cli::unknown_mode opt_mode,
          ::bpkg::cli::unknown_mode arg_mode)
  {
    bool opt = true;

    while (s.more ())
    {
      const char* o = s.peek ();

      if (std::strcmp (o, "--") == 0)
      {
        s.skip ();
        opt = false;
        continue;
      }

      if (opt && _parse (o, s));
      else if (opt && std::strncmp (o, "-", 1) == 0 && o[1] != '\0')
      {
        switch (opt_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_option (o);
          }
        }

        break;
      }
      else
      {
        switch (arg_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_argument (o);
          }
        }

        break;
      }
    }
  }
}

namespace bpkg
{
  ::bpkg::cli::usage_para
  print_bpkg_pkg_build_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mSYNOPSIS\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mbpkg pkg-build\033[0m|\033[1mbuild\033[0m [\033[4moptions\033[0m] ([\033[4mscheme\033[0m:]\033[4mpkg\033[0m[/\033[4mver\033[0m] | \033[4mfile\033[0m | \033[4mdir\033[0m/)...\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mDESCRIPTION\033[0m" << ::std::endl
       << ::std::endl
       << "The \033[1mpkg-build\033[0m command builds one or more packages including all their" << ::std::endl
       << "prerequisites. Besides building new packages, this command is also used to" << ::std::endl
       << "upgrade or downgrade packages that already exists in the configuration." << ::std::endl
       << ::std::endl
       << "Each package can be specified as just the name (\033[4mpkg\033[0m) with optional package" << ::std::endl
       << "version (\033[4mver\033[0m) in which case the source code for the package will be" << ::std::endl
       << "automatically fetched from one of the repositories. See the \033[1mbpkg-rep-add(1)\033[0m and" << ::std::endl
       << "\033[1mbpkg-rep-fetch(1)\033[0m commands for more information on package repositories. If" << ::std::endl
       << "\033[4mver\033[0m is not specified, then the latest available version will be fetched. To" << ::std::endl
       << "downgrade, the desired version must be specified explicitly." << ::std::endl
       << ::std::endl
       << "A package name (\033[4mpkg\033[0m) can also be prefixed with a package scheme (\033[4mscheme\033[0m:)." << ::std::endl
       << "Currently the only recognized scheme is \033[1msys:\033[0m which instructs \033[1mpkg-build\033[0m to" << ::std::endl
       << "configure the package as available from the system rather than building it from" << ::std::endl
       << "source. If the system package version (\033[4mver\033[0m) is not specified, then it is" << ::std::endl
       << "considered to be unknown but satisfying any dependency constraint. Such a" << ::std::endl
       << "version is displayed as \033[1m*\033[0m. In certain cases you may want to indicate that a" << ::std::endl
       << "certain package is available from the system but only add it to the" << ::std::endl
       << "configuration if it is required by other packages being built. In this case you" << ::std::endl
       << "can use the \033[1m?sys:\033[0m system scheme variant." << ::std::endl
       << ::std::endl
       << "Alternatively, a package can be specified as either the path to the package" << ::std::endl
       << "archive (\033[4mfile\033[0m) or to the package directory (\033[4mdir\033[0m/; note that it must end with a" << ::std::endl
       << "directory separator). See the \033[1mbpkg-pkg-fetch(1)\033[0m and \033[1mbpkg-pkg-unpack(1)\033[0m commands" << ::std::endl
       << "for more information on the semantics of specifying the package as an archive" << ::std::endl
       << "or a directory." << ::std::endl
       << ::std::endl
       << "Packages that are specified explicitly on the command line will be \033[4mheld\033[0m, that" << ::std::endl
       << "is, they will not be considered for automatic removal if they no longer have" << ::std::endl
       << "any dependents. Packages that are specified with the explicit package version" << ::std::endl
       << "(\033[4mver\033[0m) or as an archive or directory, will, in addition, have their versions" << ::std::endl
       << "held, that is, they will not be automatically upgraded." << ::std::endl
       << ::std::endl
       << "The \033[1mpkg-build\033[0m command also supports several options (described below) that" << ::std::endl
       << "allow you to control the amount of work that will be done." << ::std::endl;

    p = ::bpkg::pkg_build_options::print_usage (os, ::bpkg::cli::usage_para::text);

    return p;
  }
}

// Begin epilogue.
//
//
// End epilogue.

