// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

// Begin prologue.
//
#include <bpkg/types-parsers>
//
// End prologue.

#include <bpkg/pkg-status-options>

#include <map>
#include <set>
#include <string>
#include <vector>
#include <ostream>
#include <sstream>

namespace bpkg
{
  namespace cli
  {
    template <typename X>
    struct parser
    {
      static void
      parse (X& x, bool& xs, scanner& s)
      {
        using namespace std;

        string o (s.next ());

        if (s.more ())
        {
          string v (s.next ());
          istringstream is (v);
          if (!(is >> x && is.peek () == istringstream::traits_type::eof ()))
            throw invalid_value (o, v);
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <>
    struct parser<bool>
    {
      static void
      parse (bool& x, scanner& s)
      {
        s.next ();
        x = true;
      }
    };

    template <>
    struct parser<std::string>
    {
      static void
      parse (std::string& x, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
          x = s.next ();
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X>
    struct parser<std::vector<X> >
    {
      static void
      parse (std::vector<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.push_back (x);
        xs = true;
      }
    };

    template <typename X>
    struct parser<std::set<X> >
    {
      static void
      parse (std::set<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.insert (x);
        xs = true;
      }
    };

    template <typename K, typename V>
    struct parser<std::map<K, V> >
    {
      static void
      parse (std::map<K, V>& m, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
        {
          std::string ov (s.next ());
          std::string::size_type p = ov.find ('=');

          K k = K ();
          V v = V ();
          std::string kstr (ov, 0, p);
          std::string vstr (ov, (p != std::string::npos ? p + 1 : ov.size ()));

          int ac (2);
          char* av[] = 
          {
            const_cast<char*> (o), 0
          };

          bool dummy;
          if (!kstr.empty ())
          {
            av[1] = const_cast<char*> (kstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<K>::parse (k, dummy, s);
          }

          if (!vstr.empty ())
          {
            av[1] = const_cast<char*> (vstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<V>::parse (v, dummy, s);
          }

          m[k] = v;
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X, typename T, T X::*M>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, s);
    }

    template <typename X, typename T, T X::*M, bool X::*S>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, x.*S, s);
    }
  }
}

#include <map>
#include <cstring>

namespace bpkg
{
  // pkg_status_options
  //

  pkg_status_options::
  pkg_status_options ()
  {
  }

  void pkg_status_options::
  parse (int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
  }

  void pkg_status_options::
  parse (int start,
         int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
  }

  void pkg_status_options::
  parse (int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void pkg_status_options::
  parse (int start,
         int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void pkg_status_options::
  parse (::bpkg::cli::scanner& s,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    _parse (s, opt, arg);
  }

  ::bpkg::cli::usage_para pkg_status_options::
  print_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mPKG-STATUS OPTIONS\033[0m" << ::std::endl;

    p = ::bpkg::cli::usage_para::text;

    // configuration_options base
    //
    p = ::bpkg::configuration_options::print_usage (os, p);

    return p;
  }

  typedef
  std::map<std::string, void (*) (pkg_status_options&, ::bpkg::cli::scanner&)>
  _cli_pkg_status_options_map;

  static _cli_pkg_status_options_map _cli_pkg_status_options_map_;

  struct _cli_pkg_status_options_map_init
  {
    _cli_pkg_status_options_map_init ()
    {
    }
  };

  static _cli_pkg_status_options_map_init _cli_pkg_status_options_map_init_;

  bool pkg_status_options::
  _parse (const char* o, ::bpkg::cli::scanner& s)
  {
    _cli_pkg_status_options_map::const_iterator i (_cli_pkg_status_options_map_.find (o));

    if (i != _cli_pkg_status_options_map_.end ())
    {
      (*(i->second)) (*this, s);
      return true;
    }

    // configuration_options base
    //
    if (::bpkg::configuration_options::_parse (o, s))
      return true;

    return false;
  }

  void pkg_status_options::
  _parse (::bpkg::cli::scanner& s,
          ::bpkg::cli::unknown_mode opt_mode,
          ::bpkg::cli::unknown_mode arg_mode)
  {
    bool opt = true;

    while (s.more ())
    {
      const char* o = s.peek ();

      if (std::strcmp (o, "--") == 0)
      {
        s.skip ();
        opt = false;
        continue;
      }

      if (opt && _parse (o, s));
      else if (opt && std::strncmp (o, "-", 1) == 0 && o[1] != '\0')
      {
        switch (opt_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_option (o);
          }
        }

        break;
      }
      else
      {
        switch (arg_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_argument (o);
          }
        }

        break;
      }
    }
  }
}

namespace bpkg
{
  ::bpkg::cli::usage_para
  print_bpkg_pkg_status_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mSYNOPSIS\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mbpkg pkg-status\033[0m|\033[1mstatus\033[0m [\033[4moptions\033[0m] \033[4mpkg\033[0m[/\033[4mver\033[0m]...\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mDESCRIPTION\033[0m" << ::std::endl
       << ::std::endl
       << "The \033[1mpkg-status\033[0m command prints the status of the specified packages or, if \033[4mver\033[0m" << ::std::endl
       << "is specified, package versions. Note that the status is written to \033[1mSTDOUT\033[0m, not" << ::std::endl
       << "\033[1mSTDERR\033[0m." << ::std::endl
       << ::std::endl
       << "The status output format is regular. If several packages were specified, then" << ::std::endl
       << "each line starts with the package name (and version, if specified) followed by" << ::std::endl
       << "'\033[1m:\033[0m'. Then comes one of the status words listed below. Some of them can be" << ::std::endl
       << "optionally followed by '\033[1m,\033[0m' (no spaces) and a sub-status word." << ::std::endl
       << ::std::endl
       << "\033[1munknown\033[0m" << ::std::endl
       << "    Package is not part of the configuration nor available from any of the" << ::std::endl
       << "    repositories." << ::std::endl
       << "\033[1mavailable\033[0m" << ::std::endl
       << "    Package is not part of the configuration but is available from one of the" << ::std::endl
       << "    repositories." << ::std::endl
       << "\033[1mfetched\033[0m" << ::std::endl
       << "    Package is part of the configuration and is fetched." << ::std::endl
       << "\033[1munpacked\033[0m" << ::std::endl
       << "    Package is part of the configuration and is unpacked." << ::std::endl
       << "\033[1mconfigured\033[0m" << ::std::endl
       << "    Package is part of the configuration and is configured. May be followed by" << ::std::endl
       << "    the \033[1msystem\033[0m sub-status indicating a package coming from the system. The" << ::std::endl
       << "    version of such a system package (described below) may be the special '\033[1m*\033[0m'" << ::std::endl
       << "    value indicating a wildcard version." << ::std::endl
       << "\033[1mbroken\033[0m" << ::std::endl
       << "    Package is part of the configuration and is broken (broken packages can" << ::std::endl
       << "    only be purged; see \033[1mbpkg-pkg-purge(1)\033[0m)." << ::std::endl
       << ::std::endl
       << "If only the package name was specified without the package version, then the" << ::std::endl
       << "\033[1mavailable\033[0m status word is followed by the list of available versions. The last" << ::std::endl
       << "version on this list may have the \033[1msys:\033[0m prefix indicating an available system" << ::std::endl
       << "version. Such a system version may be the special '\033[1m?\033[0m' value indicating that a" << ::std::endl
       << "package may or may not be available from the system and its version is unknown." << ::std::endl
       << ::std::endl
       << "Similarly, if only the package name was specified, then the \033[1mfetched\033[0m, \033[1munpacked\033[0m," << ::std::endl
       << "\033[1mconfigured\033[0m, and \033[1mbroken\033[0m status words are followed by the version of the package." << ::std::endl
       << "After the package version, these status words may be followed by one or more" << ::std::endl
       << "sub-status words. Currently, these can be \033[1mhold_package\033[0m (package should not be" << ::std::endl
       << "automatically dropped) and \033[1mhold_version\033[0m (package should not be automatically" << ::std::endl
       << "upgraded). Finally, if only the package name was specified and newer versions" << ::std::endl
       << "are available from some of the repositories, then the sub-status word is" << ::std::endl
       << "followed by '\033[1m;\033[0m', the \033[1mavailable\033[0m status word, and the list of newer versions." << ::std::endl
       << ::std::endl
       << "Below are some examples, assuming the configuration has \033[1mlibfoo\033[0m \033[1m1.0.0\033[0m configured" << ::std::endl
       << "and held as well as \033[1mlibfoo\033[0m \033[1m1.1.0\033[0m and \033[1m1.1.1\033[0m available from source and \033[1m1.1.0\033[0m from" << ::std::endl
       << "the system." << ::std::endl
       << ::std::endl
       << "bpkg status libbar" << ::std::endl
       << "unknown" << ::std::endl
       << ::std::endl
       << "bpkg status libbar/1.0.0" << ::std::endl
       << "unknown" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo/1.0.0" << ::std::endl
       << "configured hold_package" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo/1.1.0" << ::std::endl
       << "available 1.1.0 sys:1.1.0" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo/1.1.1" << ::std::endl
       << "available" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo" << ::std::endl
       << "configured 1.0.0 hold_package; available 1.1.0 1.1.1 sys:1.1.0" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo/1.0.0 libbar" << ::std::endl
       << "libfoo/1.0.0: configured hold_package" << ::std::endl
       << "libbar: unknown" << ::std::endl
       << ::std::endl
       << "Assuming now that we dropped \033[1mlibfoo\033[0m from the configuration:" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo/1.0.0" << ::std::endl
       << "unknown" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo" << ::std::endl
       << "available 1.1.0 1.1.1 sys:1.1.0" << ::std::endl
       << ::std::endl
       << "And assuming now that we built \033[1mlibfoo\033[0m as a system package with the wildcard" << ::std::endl
       << "version:" << ::std::endl
       << ::std::endl
       << "bpkg status libfoo" << ::std::endl
       << "configured,system * hold_package; available 1.1.0 1.1.1 sys:1.1.0" << ::std::endl
       << "unknown" << ::std::endl;

    p = ::bpkg::pkg_status_options::print_usage (os, ::bpkg::cli::usage_para::text);

    return p;
  }
}

// Begin epilogue.
//
//
// End epilogue.

