// -*- C++ -*-
//
// This file was generated by CLI, a command line interface
// compiler for C++.
//

// Begin prologue.
//
#include <bpkg/types-parsers>
//
// End prologue.

#include <bpkg/rep-info-options>

#include <map>
#include <set>
#include <string>
#include <vector>
#include <ostream>
#include <sstream>

namespace bpkg
{
  namespace cli
  {
    template <typename X>
    struct parser
    {
      static void
      parse (X& x, bool& xs, scanner& s)
      {
        using namespace std;

        string o (s.next ());

        if (s.more ())
        {
          string v (s.next ());
          istringstream is (v);
          if (!(is >> x && is.peek () == istringstream::traits_type::eof ()))
            throw invalid_value (o, v);
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <>
    struct parser<bool>
    {
      static void
      parse (bool& x, scanner& s)
      {
        s.next ();
        x = true;
      }
    };

    template <>
    struct parser<std::string>
    {
      static void
      parse (std::string& x, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
          x = s.next ();
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X>
    struct parser<std::vector<X> >
    {
      static void
      parse (std::vector<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.push_back (x);
        xs = true;
      }
    };

    template <typename X>
    struct parser<std::set<X> >
    {
      static void
      parse (std::set<X>& c, bool& xs, scanner& s)
      {
        X x;
        bool dummy;
        parser<X>::parse (x, dummy, s);
        c.insert (x);
        xs = true;
      }
    };

    template <typename K, typename V>
    struct parser<std::map<K, V> >
    {
      static void
      parse (std::map<K, V>& m, bool& xs, scanner& s)
      {
        const char* o (s.next ());

        if (s.more ())
        {
          std::string ov (s.next ());
          std::string::size_type p = ov.find ('=');

          K k = K ();
          V v = V ();
          std::string kstr (ov, 0, p);
          std::string vstr (ov, (p != std::string::npos ? p + 1 : ov.size ()));

          int ac (2);
          char* av[] = 
          {
            const_cast<char*> (o), 0
          };

          bool dummy;
          if (!kstr.empty ())
          {
            av[1] = const_cast<char*> (kstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<K>::parse (k, dummy, s);
          }

          if (!vstr.empty ())
          {
            av[1] = const_cast<char*> (vstr.c_str ());
            argv_scanner s (0, ac, av);
            parser<V>::parse (v, dummy, s);
          }

          m[k] = v;
        }
        else
          throw missing_value (o);

        xs = true;
      }
    };

    template <typename X, typename T, T X::*M>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, s);
    }

    template <typename X, typename T, T X::*M, bool X::*S>
    void
    thunk (X& x, scanner& s)
    {
      parser<T>::parse (x.*M, x.*S, s);
    }
  }
}

#include <map>
#include <cstring>

namespace bpkg
{
  // rep_info_options
  //

  rep_info_options::
  rep_info_options ()
  : name_ (),
    cert_fingerprint_ (),
    cert_name_ (),
    cert_organization_ (),
    cert_email_ (),
    repositories_ (),
    packages_ (),
    manifest_ (),
    directory_ (),
    directory_specified_ (false)
  {
  }

  void rep_info_options::
  parse (int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
  }

  void rep_info_options::
  parse (int start,
         int& argc,
         char** argv,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
  }

  void rep_info_options::
  parse (int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void rep_info_options::
  parse (int start,
         int& argc,
         char** argv,
         int& end,
         bool erase,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    ::bpkg::cli::argv_scanner s (start, argc, argv, erase);
    _parse (s, opt, arg);
    end = s.end ();
  }

  void rep_info_options::
  parse (::bpkg::cli::scanner& s,
         ::bpkg::cli::unknown_mode opt,
         ::bpkg::cli::unknown_mode arg)
  {
    _parse (s, opt, arg);
  }

  ::bpkg::cli::usage_para rep_info_options::
  print_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mREP-INFO OPTIONS\033[0m" << ::std::endl;

    os << std::endl
       << "\033[1m--name\033[0m|\033[1m-n\033[0m               Print the repository's name and location." << ::std::endl;

    os << std::endl
       << "\033[1m--cert-fingerprint\033[0m      Print the repository's certificate fingerprint or empty" << ::std::endl
       << "                        line if the repository is unsigned." << ::std::endl;

    os << std::endl
       << "\033[1m--cert-name\033[0m             Print the repository's certificate common name (CN) or" << ::std::endl
       << "                        empty line if the repository is unsigned." << ::std::endl;

    os << std::endl
       << "\033[1m--cert-organization\033[0m     Print the repository's certificate organization name" << ::std::endl
       << "                        (O) or empty line if the repository is unsigned." << ::std::endl;

    os << std::endl
       << "\033[1m--cert-email\033[0m            Print the repository's certificate email or empty line" << ::std::endl
       << "                        if the repository is unsigned." << ::std::endl;

    os << std::endl
       << "\033[1m--repositories\033[0m|\033[1m-r\033[0m       Print the list of complement and prerequisite" << ::std::endl
       << "                        repositories." << ::std::endl;

    os << std::endl
       << "\033[1m--packages\033[0m|\033[1m-p\033[0m           Print the list of available packages." << ::std::endl;

    os << std::endl
       << "\033[1m--manifest\033[0m|\033[1m-m\033[0m           Instead of printing the information in the" << ::std::endl
       << "                        human-readable form, dump it as manifest(s). Normally" << ::std::endl
       << "                        you would use this option in combination with" << ::std::endl
       << "                        \033[1m--packages|-p\033[0m or \033[1m--repositories|-r\033[0m to only dump one of" << ::std::endl
       << "                        the manifests." << ::std::endl;

    os << std::endl
       << "\033[1m--directory\033[0m|\033[1m-d\033[0m \033[4mdir\033[0m      Use configuration in \033[4mdir\033[0m for the trusted certificate" << ::std::endl
       << "                        database." << ::std::endl;

    p = ::bpkg::cli::usage_para::option;

    // common_options base
    //
    p = ::bpkg::common_options::print_usage (os, p);

    return p;
  }

  typedef
  std::map<std::string, void (*) (rep_info_options&, ::bpkg::cli::scanner&)>
  _cli_rep_info_options_map;

  static _cli_rep_info_options_map _cli_rep_info_options_map_;

  struct _cli_rep_info_options_map_init
  {
    _cli_rep_info_options_map_init ()
    {
      _cli_rep_info_options_map_["--name"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::name_ >;
      _cli_rep_info_options_map_["-n"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::name_ >;
      _cli_rep_info_options_map_["--cert-fingerprint"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::cert_fingerprint_ >;
      _cli_rep_info_options_map_["--cert-name"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::cert_name_ >;
      _cli_rep_info_options_map_["--cert-organization"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::cert_organization_ >;
      _cli_rep_info_options_map_["--cert-email"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::cert_email_ >;
      _cli_rep_info_options_map_["--repositories"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::repositories_ >;
      _cli_rep_info_options_map_["-r"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::repositories_ >;
      _cli_rep_info_options_map_["--packages"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::packages_ >;
      _cli_rep_info_options_map_["-p"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::packages_ >;
      _cli_rep_info_options_map_["--manifest"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::manifest_ >;
      _cli_rep_info_options_map_["-m"] = 
      &::bpkg::cli::thunk< rep_info_options, bool, &rep_info_options::manifest_ >;
      _cli_rep_info_options_map_["--directory"] = 
      &::bpkg::cli::thunk< rep_info_options, string, &rep_info_options::directory_,
        &rep_info_options::directory_specified_ >;
      _cli_rep_info_options_map_["-d"] = 
      &::bpkg::cli::thunk< rep_info_options, string, &rep_info_options::directory_,
        &rep_info_options::directory_specified_ >;
    }
  };

  static _cli_rep_info_options_map_init _cli_rep_info_options_map_init_;

  bool rep_info_options::
  _parse (const char* o, ::bpkg::cli::scanner& s)
  {
    _cli_rep_info_options_map::const_iterator i (_cli_rep_info_options_map_.find (o));

    if (i != _cli_rep_info_options_map_.end ())
    {
      (*(i->second)) (*this, s);
      return true;
    }

    // common_options base
    //
    if (::bpkg::common_options::_parse (o, s))
      return true;

    return false;
  }

  void rep_info_options::
  _parse (::bpkg::cli::scanner& s,
          ::bpkg::cli::unknown_mode opt_mode,
          ::bpkg::cli::unknown_mode arg_mode)
  {
    bool opt = true;

    while (s.more ())
    {
      const char* o = s.peek ();

      if (std::strcmp (o, "--") == 0)
      {
        s.skip ();
        opt = false;
        continue;
      }

      if (opt && _parse (o, s));
      else if (opt && std::strncmp (o, "-", 1) == 0 && o[1] != '\0')
      {
        switch (opt_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_option (o);
          }
        }

        break;
      }
      else
      {
        switch (arg_mode)
        {
          case ::bpkg::cli::unknown_mode::skip:
          {
            s.skip ();
            continue;
          }
          case ::bpkg::cli::unknown_mode::stop:
          {
            break;
          }
          case ::bpkg::cli::unknown_mode::fail:
          {
            throw ::bpkg::cli::unknown_argument (o);
          }
        }

        break;
      }
    }
  }
}

namespace bpkg
{
  ::bpkg::cli::usage_para
  print_bpkg_rep_info_usage (::std::ostream& os, ::bpkg::cli::usage_para p)
  {
    CLI_POTENTIALLY_UNUSED (os);

    if (p != ::bpkg::cli::usage_para::none)
      os << ::std::endl;

    os << "\033[1mSYNOPSIS\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mbpkg rep-info\033[0m [\033[4moptions\033[0m] \033[4mrep\033[0m\033[0m" << ::std::endl
       << ::std::endl
       << "\033[1mDESCRIPTION\033[0m" << ::std::endl
       << ::std::endl
       << "The \033[1mrep-info\033[0m command prints various information about the specified repository." << ::std::endl
       << "By default it print the repository's name and location as the first line. If" << ::std::endl
       << "the repository is signed, the certificate information (name/organization/email)" << ::std::endl
       << "is printed as the next line following by the certificate fingerprint. Then" << ::std::endl
       << "comes the list of complement and prerequisite repositories followed by the list" << ::std::endl
       << "of available packages." << ::std::endl
       << ::std::endl
       << "This default format can be altered in various ways using options listed below." << ::std::endl
       << "Note also that the information is written to \033[1mSTDOUT\033[0m, not \033[1mSTDERR\033[0m." << ::std::endl
       << ::std::endl
       << "If the current working directory contains a \033[1mbpkg\033[0m configuration, then \033[1mrep-info\033[0m" << ::std::endl
       << "will use its certificate database for the repository authentication. That is," << ::std::endl
       << "it will trust the repository's certificate if it is already trusted by the" << ::std::endl
       << "configuration. Otherwise it will add the certificate to the configuration if" << ::std::endl
       << "you confirm it is trusted. You can specify an alternative configuration" << ::std::endl
       << "directory with the \033[1m--directory|-d\033[0m option. To disable using the configuration in" << ::std::endl
       << "the current working directory pass this option with an empty path." << ::std::endl;

    p = ::bpkg::rep_info_options::print_usage (os, ::bpkg::cli::usage_para::text);

    return p;
  }
}

// Begin epilogue.
//
//
// End epilogue.

